/*
 * 
 */
package net.officefloor.model.woof;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class WoofAccessInputModel extends AbstractModel implements ItemModel<WoofAccessInputModel> {

    public static enum WoofAccessInputEvent {
     CHANGE_WOOF_ACCESS_INPUT_NAME, CHANGE_PARAMETER_TYPE, ADD_WOOF_TEMPLATE_OUTPUT, REMOVE_WOOF_TEMPLATE_OUTPUT, ADD_WOOF_SECTION_OUTPUT, REMOVE_WOOF_SECTION_OUTPUT
    }

    /**
     * Default constructor.
     */
    public WoofAccessInputModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public WoofAccessInputModel(
      String woofAccessInputName
    , String parameterType
    ) {
        this.woofAccessInputName = woofAccessInputName;
        this.parameterType = parameterType;
    }

    /**
     * Convenience constructor.
     */
    public WoofAccessInputModel(
      String woofAccessInputName
    , String parameterType
    , WoofTemplateOutputToWoofAccessInputModel[] woofTemplateOutput
    , WoofSectionOutputToWoofAccessInputModel[] woofSectionOutput
    ) {
        this.woofAccessInputName = woofAccessInputName;
        this.parameterType = parameterType;
        if (woofTemplateOutput != null) {
            for (WoofTemplateOutputToWoofAccessInputModel model : woofTemplateOutput) {
                this.woofTemplateOutput.add(model);
            }
        }
        if (woofSectionOutput != null) {
            for (WoofSectionOutputToWoofAccessInputModel model : woofSectionOutput) {
                this.woofSectionOutput.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public WoofAccessInputModel(
      String woofAccessInputName
    , String parameterType
    , WoofTemplateOutputToWoofAccessInputModel[] woofTemplateOutput
    , WoofSectionOutputToWoofAccessInputModel[] woofSectionOutput
    , int x
    , int y
    ) {
        this.woofAccessInputName = woofAccessInputName;
        this.parameterType = parameterType;
        if (woofTemplateOutput != null) {
            for (WoofTemplateOutputToWoofAccessInputModel model : woofTemplateOutput) {
                this.woofTemplateOutput.add(model);
            }
        }
        if (woofSectionOutput != null) {
            for (WoofSectionOutputToWoofAccessInputModel model : woofSectionOutput) {
                this.woofSectionOutput.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Woof access input name.
     */
    private String woofAccessInputName;

    public String getWoofAccessInputName() {
        return this.woofAccessInputName;
    }

    public void setWoofAccessInputName(String woofAccessInputName) {
        String oldValue = this.woofAccessInputName;
        this.woofAccessInputName = woofAccessInputName;
        this.changeField(oldValue, this.woofAccessInputName, WoofAccessInputEvent.CHANGE_WOOF_ACCESS_INPUT_NAME);
    }

    /**
     * Parameter type.
     */
    private String parameterType;

    public String getParameterType() {
        return this.parameterType;
    }

    public void setParameterType(String parameterType) {
        String oldValue = this.parameterType;
        this.parameterType = parameterType;
        this.changeField(oldValue, this.parameterType, WoofAccessInputEvent.CHANGE_PARAMETER_TYPE);
    }


    /**
     * Woof template output.
     */
    private List<WoofTemplateOutputToWoofAccessInputModel> woofTemplateOutput = new LinkedList<WoofTemplateOutputToWoofAccessInputModel>();

    public List<WoofTemplateOutputToWoofAccessInputModel> getWoofTemplateOutputs() {
        return this.woofTemplateOutput;
    }

    public void addWoofTemplateOutput(WoofTemplateOutputToWoofAccessInputModel woofTemplateOutput) {
        this.addItemToList(woofTemplateOutput, this.woofTemplateOutput, WoofAccessInputEvent.ADD_WOOF_TEMPLATE_OUTPUT);
    }

    public void removeWoofTemplateOutput(WoofTemplateOutputToWoofAccessInputModel woofTemplateOutput) {
        this.removeItemFromList(woofTemplateOutput, this.woofTemplateOutput, WoofAccessInputEvent.REMOVE_WOOF_TEMPLATE_OUTPUT);
    }

    /**
     * Woof section output.
     */
    private List<WoofSectionOutputToWoofAccessInputModel> woofSectionOutput = new LinkedList<WoofSectionOutputToWoofAccessInputModel>();

    public List<WoofSectionOutputToWoofAccessInputModel> getWoofSectionOutputs() {
        return this.woofSectionOutput;
    }

    public void addWoofSectionOutput(WoofSectionOutputToWoofAccessInputModel woofSectionOutput) {
        this.addItemToList(woofSectionOutput, this.woofSectionOutput, WoofAccessInputEvent.ADD_WOOF_SECTION_OUTPUT);
    }

    public void removeWoofSectionOutput(WoofSectionOutputToWoofAccessInputModel woofSectionOutput) {
        this.removeItemFromList(woofSectionOutput, this.woofSectionOutput, WoofAccessInputEvent.REMOVE_WOOF_SECTION_OUTPUT);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<WoofAccessInputModel> removeConnections() {
        RemoveConnectionsAction<WoofAccessInputModel> _action = new RemoveConnectionsAction<WoofAccessInputModel>(this);
        _action.disconnect(this.woofTemplateOutput);
        _action.disconnect(this.woofSectionOutput);
        return _action;
    }
}
