/*
 * 
 */
package net.officefloor.model.woof;

import java.util.List;
import java.util.LinkedList;

import javax.annotation.Generated;

import net.officefloor.model.AbstractModel;
import net.officefloor.model.ItemModel;
import net.officefloor.model.RemoveConnectionsAction;

@Generated("net.officefloor.model.generate.ModelGenerator")
public class WoofAccessModel extends AbstractModel implements ItemModel<WoofAccessModel> {

    public static enum WoofAccessEvent {
     CHANGE_HTTP_SECURITY_SOURCE_CLASS_NAME, CHANGE_TIMEOUT, ADD_PROPERTY, REMOVE_PROPERTY, ADD_INPUT, REMOVE_INPUT, ADD_OUTPUT, REMOVE_OUTPUT
    }

    /**
     * Default constructor.
     */
    public WoofAccessModel() {
    }

    /**
     * Convenience constructor for new non-linked instance.
     */
    public WoofAccessModel(
      String httpSecuritySourceClassName
    , long timeout
    ) {
        this.httpSecuritySourceClassName = httpSecuritySourceClassName;
        this.timeout = timeout;
    }

    /**
     * Convenience constructor.
     */
    public WoofAccessModel(
      String httpSecuritySourceClassName
    , long timeout
    , PropertyModel[] property
    , WoofAccessInputModel[] input
    , WoofAccessOutputModel[] output
    ) {
        this.httpSecuritySourceClassName = httpSecuritySourceClassName;
        this.timeout = timeout;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (input != null) {
            for (WoofAccessInputModel model : input) {
                this.input.add(model);
            }
        }
        if (output != null) {
            for (WoofAccessOutputModel model : output) {
                this.output.add(model);
            }
        }
    }

    /**
     * Convenience constructor allowing XY initialising.
     */
    public WoofAccessModel(
      String httpSecuritySourceClassName
    , long timeout
    , PropertyModel[] property
    , WoofAccessInputModel[] input
    , WoofAccessOutputModel[] output
    , int x
    , int y
    ) {
        this.httpSecuritySourceClassName = httpSecuritySourceClassName;
        this.timeout = timeout;
        if (property != null) {
            for (PropertyModel model : property) {
                this.property.add(model);
            }
        }
        if (input != null) {
            for (WoofAccessInputModel model : input) {
                this.input.add(model);
            }
        }
        if (output != null) {
            for (WoofAccessOutputModel model : output) {
                this.output.add(model);
            }
        }
        this.setX(x);
        this.setY(y);
    }

    /**
     * Http security source class name.
     */
    private String httpSecuritySourceClassName;

    public String getHttpSecuritySourceClassName() {
        return this.httpSecuritySourceClassName;
    }

    public void setHttpSecuritySourceClassName(String httpSecuritySourceClassName) {
        String oldValue = this.httpSecuritySourceClassName;
        this.httpSecuritySourceClassName = httpSecuritySourceClassName;
        this.changeField(oldValue, this.httpSecuritySourceClassName, WoofAccessEvent.CHANGE_HTTP_SECURITY_SOURCE_CLASS_NAME);
    }

    /**
     * Timeout.
     */
    private long timeout;

    public long getTimeout() {
        return this.timeout;
    }

    public void setTimeout(long timeout) {
        long oldValue = this.timeout;
        this.timeout = timeout;
        this.changeField(oldValue, this.timeout, WoofAccessEvent.CHANGE_TIMEOUT);
    }


    /**
     * Property.
     */
    private List<PropertyModel> property = new LinkedList<PropertyModel>();

    public List<PropertyModel> getProperties() {
        return this.property;
    }

    public void addProperty(PropertyModel property) {
        this.addItemToList(property, this.property, WoofAccessEvent.ADD_PROPERTY);
    }

    public void removeProperty(PropertyModel property) {
        this.removeItemFromList(property, this.property, WoofAccessEvent.REMOVE_PROPERTY);
    }

    /**
     * Input.
     */
    private List<WoofAccessInputModel> input = new LinkedList<WoofAccessInputModel>();

    public List<WoofAccessInputModel> getInputs() {
        return this.input;
    }

    public void addInput(WoofAccessInputModel input) {
        this.addItemToList(input, this.input, WoofAccessEvent.ADD_INPUT);
    }

    public void removeInput(WoofAccessInputModel input) {
        this.removeItemFromList(input, this.input, WoofAccessEvent.REMOVE_INPUT);
    }

    /**
     * Output.
     */
    private List<WoofAccessOutputModel> output = new LinkedList<WoofAccessOutputModel>();

    public List<WoofAccessOutputModel> getOutputs() {
        return this.output;
    }

    public void addOutput(WoofAccessOutputModel output) {
        this.addItemToList(output, this.output, WoofAccessEvent.ADD_OUTPUT);
    }

    public void removeOutput(WoofAccessOutputModel output) {
        this.removeItemFromList(output, this.output, WoofAccessEvent.REMOVE_OUTPUT);
    }


    /**
     * Remove Connections.
     */
    public RemoveConnectionsAction<WoofAccessModel> removeConnections() {
        RemoveConnectionsAction<WoofAccessModel> _action = new RemoveConnectionsAction<WoofAccessModel>(this);
        return _action;
    }
}
